diff --git a/gcc/value-prof.c b/gcc/value-prof.c
index 0d033ef..967b01f 100644
--- a/gcc/value-prof.c
+++ b/gcc/value-prof.c
@@ -125,9 +125,9 @@ along with GCC; see the file COPYING3.  If not see
      and gimple_value_profile_transformations table-driven, perhaps...
 */
 
-static tree gimple_divmod_fixed_value (gimple, tree, int, gcov_type, gcov_type);
-static tree gimple_mod_pow2 (gimple, int, gcov_type, gcov_type);
-static tree gimple_mod_subtract (gimple, int, int, int, gcov_type, gcov_type,
+static tree gimple_divmod_fixed_value (gimple *, tree, int, gcov_type, gcov_type);
+static tree gimple_mod_pow2 (gimple *, int, gcov_type, gcov_type);
+static tree gimple_mod_subtract (gimple *, int, int, int, gcov_type, gcov_type,
 				 gcov_type);
 static bool gimple_divmod_fixed_value_transform (gimple_stmt_iterator *);
 static bool gimple_mod_pow2_value_transform (gimple_stmt_iterator *);
@@ -139,7 +139,7 @@ static bool gimple_ic_transform (gimple_stmt_iterator *);
 
 static histogram_value
 gimple_alloc_histogram_value (struct function *fun ATTRIBUTE_UNUSED,
-			      enum hist_type type, gimple stmt, tree value)
+			      enum hist_type type, gimple *stmt, tree value)
 {
    histogram_value hist = (histogram_value) xcalloc (1, sizeof (*hist));
    hist->hvalue.value = value;
@@ -161,13 +161,13 @@ histogram_hash (const void *x)
 static int
 histogram_eq (const void *x, const void *y)
 {
-  return ((const_histogram_value) x)->hvalue.stmt == (const_gimple) y;
+  return ((const_histogram_value) x)->hvalue.stmt == (const gimple *) y;
 }
 
 /* Set histogram for STMT.  */
 
 static void
-set_histogram_value (struct function *fun, gimple stmt, histogram_value hist)
+set_histogram_value (struct function *fun, gimple *stmt, histogram_value hist)
 {
   void **loc;
   if (!hist && !VALUE_HISTOGRAMS (fun))
@@ -190,7 +190,7 @@ set_histogram_value (struct function *fun, gimple stmt, histogram_value hist)
 /* Get histogram list for STMT.  */
 
 histogram_value
-gimple_histogram_value (struct function *fun, gimple stmt)
+gimple_histogram_value (struct function *fun, gimple *stmt)
 {
   if (!VALUE_HISTOGRAMS (fun))
     return NULL;
@@ -201,7 +201,7 @@ gimple_histogram_value (struct function *fun, gimple stmt)
 /* Add histogram for STMT.  */
 
 void
-gimple_add_histogram_value (struct function *fun, gimple stmt,
+gimple_add_histogram_value (struct function *fun, gimple *stmt,
 			    histogram_value hist)
 {
   hist->hvalue.next = gimple_histogram_value (fun, stmt);
@@ -213,7 +213,7 @@ gimple_add_histogram_value (struct function *fun, gimple stmt,
 /* Remove histogram HIST from STMT's histogram list.  */
 
 void
-gimple_remove_histogram_value (struct function *fun, gimple stmt,
+gimple_remove_histogram_value (struct function *fun, gimple *stmt,
 			       histogram_value hist)
 {
   histogram_value hist2 = gimple_histogram_value (fun, stmt);
@@ -238,7 +238,7 @@ gimple_remove_histogram_value (struct function *fun, gimple stmt,
 /* Lookup histogram of type TYPE in the STMT.  */
 
 histogram_value
-gimple_histogram_value_of_type (struct function *fun, gimple stmt,
+gimple_histogram_value_of_type (struct function *fun, gimple *stmt,
 				enum hist_type type)
 {
   histogram_value hist;
@@ -392,7 +392,7 @@ stream_out_histogram_value (struct output_block *ob, histogram_value hist)
 /* Dump information about HIST to DUMP_FILE.  */
 
 void
-stream_in_histogram_value (struct lto_input_block *ib, gimple stmt)
+stream_in_histogram_value (struct lto_input_block *ib, gimple *stmt)
 {
   enum hist_type type;
   unsigned int ncounters = 0;
@@ -453,7 +453,7 @@ stream_in_histogram_value (struct lto_input_block *ib, gimple stmt)
 /* Dump all histograms attached to STMT to DUMP_FILE.  */
 
 void
-dump_histograms_for_stmt (struct function *fun, FILE *dump_file, gimple stmt)
+dump_histograms_for_stmt (struct function *fun, FILE *dump_file, gimple *stmt)
 {
   histogram_value hist;
   for (hist = gimple_histogram_value (fun, stmt); hist; hist = hist->hvalue.next)
@@ -463,7 +463,7 @@ dump_histograms_for_stmt (struct function *fun, FILE *dump_file, gimple stmt)
 /* Remove all histograms associated with STMT.  */
 
 void
-gimple_remove_stmt_histograms (struct function *fun, gimple stmt)
+gimple_remove_stmt_histograms (struct function *fun, gimple *stmt)
 {
   histogram_value val;
   while ((val = gimple_histogram_value (fun, stmt)) != NULL)
@@ -473,8 +473,8 @@ gimple_remove_stmt_histograms (struct function *fun, gimple stmt)
 /* Duplicate all histograms associates with OSTMT to STMT.  */
 
 void
-gimple_duplicate_stmt_histograms (struct function *fun, gimple stmt,
-				  struct function *ofun, gimple ostmt)
+gimple_duplicate_stmt_histograms (struct function *fun, gimple *stmt,
+				  struct function *ofun, gimple *ostmt)
 {
   histogram_value val;
   for (val = gimple_histogram_value (ofun, ostmt); val != NULL; val = val->hvalue.next)
@@ -492,7 +492,7 @@ gimple_duplicate_stmt_histograms (struct function *fun, gimple stmt,
 /* Move all histograms associated with OSTMT to STMT.  */
 
 void
-gimple_move_stmt_histograms (struct function *fun, gimple stmt, gimple ostmt)
+gimple_move_stmt_histograms (struct function *fun, gimple *stmt, gimple *ostmt)
 {
   histogram_value val = gimple_histogram_value (fun, ostmt);
   if (val)
@@ -545,7 +545,7 @@ verify_histograms (void)
   FOR_EACH_BB_FN (bb, cfun)
     for (gsi = gsi_start_bb (bb); !gsi_end_p (gsi); gsi_next (&gsi))
       {
-	gimple stmt = gsi_stmt (gsi);
+	gimple *stmt = gsi_stmt (gsi);
 
 	for (hist = gimple_histogram_value (cfun, stmt); hist;
 	     hist = hist->hvalue.next)
@@ -601,7 +601,7 @@ free_histograms (void)
    somehow.  */
 
 static bool
-check_counter (gimple stmt, const char * name,
+check_counter (gimple *stmt, const char * name,
 	       gcov_type *count, gcov_type *all, gcov_type bb_count)
 {
   if (*all != bb_count || *count > *all)
@@ -652,7 +652,7 @@ gimple_value_profile_transformations (void)
     {
       for (gsi = gsi_start_bb (bb); !gsi_end_p (gsi); gsi_next (&gsi))
 	{
-	  gimple stmt = gsi_stmt (gsi);
+	  gimple *stmt = gsi_stmt (gsi);
 	  histogram_value th = gimple_histogram_value (cfun, stmt);
 	  if (!th)
 	    continue;
@@ -705,12 +705,12 @@ gimple_value_profile_transformations (void)
    alter the original STMT.  */
 
 static tree
-gimple_divmod_fixed_value (gimple stmt, tree value, int prob, gcov_type count,
+gimple_divmod_fixed_value (gimple *stmt, tree value, int prob, gcov_type count,
 			   gcov_type all)
 {
-  gimple stmt1, stmt2, stmt3;
+  gimple *stmt1, *stmt2, *stmt3;
   tree tmp0, tmp1, tmp2;
-  gimple bb1end, bb2end, bb3end;
+  gimple *bb1end, *bb2end, *bb3end;
   basic_block bb, bb2, bb3, bb4;
   tree optype, op1, op2;
   edge e12, e13, e23, e24, e34;
@@ -792,7 +792,7 @@ gimple_divmod_fixed_value_transform (gimple_stmt_iterator *si)
   gcov_type val, count, all;
   tree result, value, tree_val;
   gcov_type prob;
-  gimple stmt;
+  gimple *stmt;
 
   stmt = gsi_stmt (*si);
   if (gimple_code (stmt) != GIMPLE_ASSIGN)
@@ -868,11 +868,11 @@ gimple_divmod_fixed_value_transform (gimple_stmt_iterator *si)
    within roundoff error).  This generates the result into a temp and returns
    the temp; it does not replace or alter the original STMT.  */
 static tree
-gimple_mod_pow2 (gimple stmt, int prob, gcov_type count, gcov_type all)
+gimple_mod_pow2 (gimple *stmt, int prob, gcov_type count, gcov_type all)
 {
-  gimple stmt1, stmt2, stmt3, stmt4;
+  gimple *stmt1, *stmt2, *stmt3, *stmt4;
   tree tmp2, tmp3;
-  gimple bb1end, bb2end, bb3end;
+  gimple *bb1end, *bb2end, *bb3end;
   basic_block bb, bb2, bb3, bb4;
   tree optype, op1, op2;
   edge e12, e13, e23, e24, e34;
@@ -954,7 +954,7 @@ gimple_mod_pow2_value_transform (gimple_stmt_iterator *si)
   gcov_type count, wrong_values, all;
   tree lhs_type, result, value;
   gcov_type prob;
-  gimple stmt;
+  gimple *stmt;
 
   stmt = gsi_stmt (*si);
   if (gimple_code (stmt) != GIMPLE_ASSIGN)
@@ -1020,12 +1020,12 @@ gimple_mod_pow2_value_transform (gimple_stmt_iterator *si)
 /* FIXME: Generalize the interface to handle NCOUNTS > 1.  */
 
 static tree
-gimple_mod_subtract (gimple stmt, int prob1, int prob2, int ncounts,
+gimple_mod_subtract (gimple *stmt, int prob1, int prob2, int ncounts,
 		     gcov_type count1, gcov_type count2, gcov_type all)
 {
-  gimple stmt1, stmt2, stmt3;
+  gimple *stmt1, *stmt2, *stmt3;
   tree tmp1;
-  gimple bb1end, bb2end = NULL, bb3end;
+  gimple *bb1end, *bb2end = NULL, *bb3end;
   basic_block bb, bb2, bb3, bb4;
   tree optype, op1, op2;
   edge e12, e23 = 0, e24, e34, e14;
@@ -1126,7 +1126,7 @@ gimple_mod_subtract_transform (gimple_stmt_iterator *si)
   gcov_type prob1, prob2;
   unsigned int i, steps;
   gcov_type count1, count2;
-  gimple stmt;
+  gimple *stmt;
 
   stmt = gsi_stmt (*si);
   if (gimple_code (stmt) != GIMPLE_ASSIGN)
@@ -1301,7 +1301,7 @@ find_func_by_profile_id (int profile_id)
    Returns true if TARGET is considered ok for call CALL_STMT.  */
 
 static bool
-check_ic_target (gimple call_stmt, struct cgraph_node *target)
+check_ic_target (gimple *call_stmt, struct cgraph_node *target)
 {
    location_t locus;
    if (gimple_check_call_matching_types (call_stmt, target->decl, true))
@@ -1323,11 +1323,11 @@ check_ic_target (gimple call_stmt, struct cgraph_node *target)
     old call
  */
 
-gimple
-gimple_ic (gimple icall_stmt, struct cgraph_node *direct_call,
+gimple *
+gimple_ic (gimple *icall_stmt, struct cgraph_node *direct_call,
 	   int prob, gcov_type count, gcov_type all)
 {
-  gimple dcall_stmt, load_stmt, cond_stmt;
+  gimple *dcall_stmt, *load_stmt, *cond_stmt;
   tree tmp0, tmp1, tmp;
   basic_block cond_bb, dcall_bb, icall_bb, join_bb = NULL;
   tree optype = build_pointer_type (void_type_node);
@@ -1426,7 +1426,7 @@ gimple_ic (gimple icall_stmt, struct cgraph_node *direct_call,
       && (dflags & ECF_NORETURN) == 0)
     {
       tree result = gimple_call_lhs (icall_stmt);
-      gimple phi = create_phi_node (result, join_bb);
+      gimple *phi = create_phi_node (result, join_bb);
       gimple_call_set_lhs (icall_stmt,
 			   duplicate_ssa_name (result, icall_stmt));
       add_phi_arg (phi, gimple_call_lhs (icall_stmt), e_ij, UNKNOWN_LOCATION);
@@ -1449,7 +1449,7 @@ gimple_ic (gimple icall_stmt, struct cgraph_node *direct_call,
 	for (psi = gsi_start_phis (e_eh->dest);
 	     !gsi_end_p (psi); gsi_next (&psi))
 	  {
-	    gimple phi = gsi_stmt (psi);
+	    gimple *phi = gsi_stmt (psi);
 	    SET_USE (PHI_ARG_DEF_PTR_FROM_EDGE (phi, e),
 		     PHI_ARG_DEF_FROM_EDGE (phi, e_eh));
 	  }
@@ -1466,7 +1466,7 @@ gimple_ic (gimple icall_stmt, struct cgraph_node *direct_call,
 static bool
 gimple_ic_transform (gimple_stmt_iterator *gsi)
 {
-  gimple stmt = gsi_stmt (*gsi);
+  gimple *stmt = gsi_stmt (*gsi);
   histogram_value histogram;
   gcov_type val, count, all, bb_all;
   struct cgraph_node *direct_call;
@@ -1553,7 +1553,7 @@ gimple_ic_transform (gimple_stmt_iterator *gsi)
    operation.
 */
 static bool
-interesting_stringop_to_profile_p (tree fndecl, gimple call, int *size_arg)
+interesting_stringop_to_profile_p (tree fndecl, gimple *call, int *size_arg)
 {
   enum built_in_function fcode = DECL_FUNCTION_CODE (fndecl);
 
@@ -1590,10 +1590,10 @@ interesting_stringop_to_profile_p (tree fndecl, gimple call, int *size_arg)
    assuming we'll propagate a true constant into ICALL_SIZE later.  */
 
 static void
-gimple_stringop_fixed_value (gimple vcall_stmt, tree icall_size, int prob,
+gimple_stringop_fixed_value (gimple *vcall_stmt, tree icall_size, int prob,
 			     gcov_type count, gcov_type all)
 {
-  gimple tmp_stmt, cond_stmt, icall_stmt;
+  gimple *tmp_stmt, *cond_stmt, *icall_stmt;
   tree tmp0, tmp1, vcall_size, optype;
   basic_block cond_bb, icall_bb, vcall_bb, join_bb;
   edge e_ci, e_cv, e_iv, e_ij, e_vj;
@@ -1665,7 +1665,7 @@ gimple_stringop_fixed_value (gimple vcall_stmt, tree icall_size, int prob,
       && TREE_CODE (gimple_call_lhs (vcall_stmt)) == SSA_NAME)
     {
       tree result = gimple_call_lhs (vcall_stmt);
-      gimple phi = create_phi_node (result, join_bb);
+      gimple *phi = create_phi_node (result, join_bb);
       gimple_call_set_lhs (vcall_stmt,
 			   duplicate_ssa_name (result, vcall_stmt));
       add_phi_arg (phi, gimple_call_lhs (vcall_stmt), e_vj, UNKNOWN_LOCATION);
@@ -1684,7 +1684,7 @@ gimple_stringop_fixed_value (gimple vcall_stmt, tree icall_size, int prob,
 static bool
 gimple_stringops_transform (gimple_stmt_iterator *gsi)
 {
-  gimple stmt = gsi_stmt (*gsi);
+  gimple *stmt = gsi_stmt (*gsi);
   tree fndecl;
   tree blck_size;
   enum built_in_function fcode;
@@ -1777,7 +1777,7 @@ gimple_stringops_transform (gimple_stmt_iterator *gsi)
 }
 
 void
-stringop_block_profile (gimple stmt, unsigned int *expected_align,
+stringop_block_profile (gimple *stmt, unsigned int *expected_align,
 			HOST_WIDE_INT *expected_size)
 {
   histogram_value histogram;
@@ -1829,7 +1829,7 @@ stringop_block_profile (gimple stmt, unsigned int *expected_align,
 /* Find values inside STMT for that we want to measure histograms for
    division/modulo optimization.  */
 static void
-gimple_divmod_values_to_profile (gimple stmt, histogram_values *values)
+gimple_divmod_values_to_profile (gimple *stmt, histogram_values *values)
 {
   tree lhs, divisor, op0, type;
   histogram_value hist;
@@ -1887,7 +1887,7 @@ gimple_divmod_values_to_profile (gimple stmt, histogram_values *values)
    indirect/virtual call optimization. */
 
 static void
-gimple_indirect_call_to_profile (gimple stmt, histogram_values *values)
+gimple_indirect_call_to_profile (gimple *stmt, histogram_values *values)
 {
   tree callee;
 
@@ -1909,7 +1909,7 @@ gimple_indirect_call_to_profile (gimple stmt, histogram_values *values)
 /* Find values inside STMT for that we want to measure histograms for
    string operations.  */
 static void
-gimple_stringops_values_to_profile (gimple stmt, histogram_values *values)
+gimple_stringops_values_to_profile (gimple *stmt, histogram_values *values)
 {
   tree fndecl;
   tree blck_size;
@@ -1945,7 +1945,7 @@ gimple_stringops_values_to_profile (gimple stmt, histogram_values *values)
    them to list VALUES.  */
 
 static void
-gimple_values_to_profile (gimple stmt, histogram_values *values)
+gimple_values_to_profile (gimple *stmt, histogram_values *values)
 {
   gimple_divmod_values_to_profile (stmt, values);
   gimple_stringops_values_to_profile (stmt, values);
diff --git a/gcc/value-prof.h b/gcc/value-prof.h
index 9d2c351..9fe619a 100644
--- a/gcc/value-prof.h
+++ b/gcc/value-prof.h
@@ -49,7 +49,7 @@ struct histogram_value_t
   struct
     {
       tree value;		/* The value to profile.  */
-      gimple stmt;		/* Insn containing the value.  */
+      gimple *stmt;		/* Insn containing the value.  */
       gcov_type *counters;		        /* Pointer to first counter.  */
       struct histogram_value_t *next;		/* Linked list pointer.  */
     } hvalue;
@@ -75,20 +75,20 @@ typedef vec<histogram_value> histogram_values;
 extern void gimple_find_values_to_profile (histogram_values *);
 extern bool gimple_value_profile_transformations (void);
 
-histogram_value gimple_histogram_value (struct function *, gimple);
-histogram_value gimple_histogram_value_of_type (struct function *, gimple,
+histogram_value gimple_histogram_value (struct function *, gimple *);
+histogram_value gimple_histogram_value_of_type (struct function *, gimple *,
 						enum hist_type);
-void gimple_add_histogram_value (struct function *, gimple, histogram_value);
-void dump_histograms_for_stmt (struct function *, FILE *, gimple);
-void gimple_remove_histogram_value (struct function *, gimple, histogram_value);
-void gimple_remove_stmt_histograms (struct function *, gimple);
-void gimple_duplicate_stmt_histograms (struct function *, gimple,
-				       struct function *, gimple);
-void gimple_move_stmt_histograms (struct function *, gimple, gimple);
+void gimple_add_histogram_value (struct function *, gimple *, histogram_value);
+void dump_histograms_for_stmt (struct function *, FILE *, gimple *);
+void gimple_remove_histogram_value (struct function *, gimple *, histogram_value);
+void gimple_remove_stmt_histograms (struct function *, gimple *);
+void gimple_duplicate_stmt_histograms (struct function *, gimple *,
+				       struct function *, gimple *);
+void gimple_move_stmt_histograms (struct function *, gimple *, gimple *);
 void verify_histograms (void);
 void free_histograms (void);
-void stringop_block_profile (gimple, unsigned int *, HOST_WIDE_INT *);
-gimple gimple_ic (gimple, struct cgraph_node *, int, gcov_type, gcov_type);
+void stringop_block_profile (gimple *, unsigned int *, HOST_WIDE_INT *);
+gimple *gimple_ic (gimple *, struct cgraph_node *, int, gcov_type, gcov_type);
 
 
 /* In tree-profile.c.  */
@@ -106,7 +106,7 @@ extern void gimple_gen_const_delta_profiler (histogram_value,
 extern void gimple_gen_average_profiler (histogram_value, unsigned, unsigned);
 extern void gimple_gen_ior_profiler (histogram_value, unsigned, unsigned);
 extern void stream_out_histogram_value (struct output_block *, histogram_value);
-extern void stream_in_histogram_value (struct lto_input_block *, gimple);
+extern void stream_in_histogram_value (struct lto_input_block *, gimple *);
 extern struct cgraph_node* find_func_by_profile_id (int func_id);
 
 
diff --git a/gcc/vtable-verify.c b/gcc/vtable-verify.c
index b99ff6c..408e73c 100644
--- a/gcc/vtable-verify.c
+++ b/gcc/vtable-verify.c
@@ -416,7 +416,7 @@ find_or_create_vtbl_map_node (tree base_class_type)
    call).  */
 
 static bool
-is_vtable_assignment_stmt (gimple stmt)
+is_vtable_assignment_stmt (gimple *stmt)
 {
 
   if (gimple_code (stmt) != GIMPLE_ASSIGN)
@@ -510,7 +510,7 @@ var_is_used_for_virtual_call_p (tree lhs, int *mem_ref_depth)
 
   FOR_EACH_IMM_USE_FAST (use_p, imm_iter, lhs)
     {
-      gimple stmt2 = USE_STMT (use_p);
+      gimple *stmt2 = USE_STMT (use_p);
 
       if (is_gimple_call (stmt2))
         {
@@ -574,7 +574,7 @@ static void
 verify_bb_vtables (basic_block bb)
 {
   gimple_seq stmts;
-  gimple stmt = NULL;
+  gimple *stmt = NULL;
   gimple_stmt_iterator gsi_vtbl_assign;
   gimple_stmt_iterator gsi_virtual_call;
 
@@ -598,7 +598,7 @@ verify_bb_vtables (basic_block bb)
           tree vtbl_var_decl = NULL_TREE;
           struct vtbl_map_node *vtable_map_node;
           tree vtbl_decl = NULL_TREE;
-          gimple call_stmt;
+          gimple *call_stmt;
           const char *vtable_name = "<unknown>";
           tree tmp0;
           bool found;
@@ -694,7 +694,7 @@ verify_bb_vtables (basic_block bb)
                   /* Replace all uses of lhs with tmp0. */
                   found = false;
                   imm_use_iterator iterator;
-                  gimple use_stmt;
+                  gimple *use_stmt;
                   FOR_EACH_IMM_USE_STMT (use_stmt, iterator, lhs)
                     {
                       use_operand_p use_p;
-- 
1.8.5.3

